//+------------------------------------------------------------------+
//|                                                   pablosupres.mq4 |
//|Dynamic support and resistance lines based on REAL price data!     |
//|            Copyright  2005, Paul Heap, indo@easyforexsignals.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Paul Heap"
#property link      "http://www.easyforexsignals.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Green
#property indicator_color4 Brown
#property indicator_color5 Red
#property indicator_color6 Blue


//---- input parameters
extern int HistoryMax= 500;
extern int AveragePeriod= 15; // no of bars to take into account when calc localsupport / resistance
extern int Reg= 1;
extern int Pluspips = 0;  // no of pips to extend the channels from the high/lows at each side of the support/resist 
extern int BarsToProcess = 800; 
extern int MinLevelGap = 30; // 20 is ok for 1 hr. it should be multiplied by the Period

double BufferMaxPrice[];
double BufferMinPrice[];


extern int LocalTimeZone= 0;
extern int DestTimeZone= 0;
   
   int TradingHoursFrom= 0;
   int TradingHoursTo= 24;
   
   int maxcount = 0;
   double levelGap;
   
    double P, Q, D, R1,R2,R3, S1,S2,S3;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

   ArrayResize(BufferMaxPrice, 400);

   //----
levelGap = MinLevelGap * Point;
   return(0);
}
  
int deinit()
{
   int obj_total= ObjectsTotal();
   
   for (int i= obj_total; i>=0; i--) {
      string name= ObjectName(i);
    
      if (StringSubstr(name,0,10)=="[PABPIVOT]") 
         ObjectDelete(name);
   }
   
   return(0);
}
  
  
int start()
{
  
   static datetime timelastupdate= 0;
     
   
   if (CurTime()-timelastupdate < 12000)
      return (0);
      
   timelastupdate= CurTime();
  
  /// RICKY D PASTED SECTION
  
    datetime startofday= 0;

   double day_high= 0;
   double day_low= 0;
   double yesterday_high= 0;
   double yesterday_open= 0;
   double yesterday_low= 0;
   double yesterday_close= 0;
   double today_open= 0;
   double today_high= 0;
   double today_low= 0;

   double rates_d1[2][6];
   double rates_h1[2][6];
   

   int tzdiff= LocalTimeZone - DestTimeZone,
       tzdiffsec= tzdiff*3600;
   
   int dayofweektoday= TimeDayOfWeek(iTime(NULL, PERIOD_H1, 0) - tzdiffsec),  // what day is today in the dest timezone?
       dayofweektofind= -1; 

   int idxfirstbaroftoday= 0,
       idxfirstbarofyesterday= 0,
       idxlastbarofyesterday= 0;
       
   switch (dayofweektoday) {
      case 6: // sat
      case 0: // sun
      case 1: // mon
            dayofweektofind= 5; // prev friday
            break;
            
      default:
            dayofweektofind= dayofweektoday -1; 
            break;
   }
   
       
   for (int i=1; i<=25; i++) {
      datetime timet= iTime(NULL, PERIOD_H1, i) - tzdiffsec;
      if (TimeDayOfWeek(timet)!=dayofweektoday) {
         idxfirstbaroftoday= i-1;
         break;
      }
   }
   


   // search  backwards for the first day of the weekday we are looking for (yesterday's last bar)
   for (int j= 0; j<=48; j++) {
      datetime timey= iTime(NULL, PERIOD_H1, i+j) - tzdiffsec;
      if (TimeDayOfWeek(timey)==dayofweektofind) {  // ignore saturdays (a Sa may happen due to TZ conversion)
         idxlastbarofyesterday= i+j;
         break;
      }
   }

 

   for (j= 1; j<=24; j++) {
      datetime timey2= iTime(NULL, PERIOD_H1, idxlastbarofyesterday+j) - tzdiffsec;
      if (TimeDayOfWeek(timey2)!=dayofweektofind) {  // ignore saturdays (a Sa may happen due to TZ conversion)
         idxfirstbarofyesterday= idxlastbarofyesterday+j-1;
         break;
      }
   }
   
   datetime timeyesterdayopen= iTime(NULL, PERIOD_H1, idxfirstbarofyesterday);
   


   // 
   // walk forward from yestday's start and collect hours within the same day and within trading hours
   //
   yesterday_high= -99999;  // not high enough to remain alltime high
   yesterday_low=  +99999;  // not low enough to remain alltime low
   
   for (j= idxfirstbarofyesterday; j>=idxlastbarofyesterday; j--) {
      int idxbar= j;
      datetime bartime= iTime(NULL, PERIOD_H1, idxbar) - tzdiffsec;
  
      if (yesterday_open==0)  // grab first value for open
         yesterday_open= iOpen(NULL, PERIOD_H1, idxbar);                      
      
      yesterday_high= MathMax(iHigh(NULL, PERIOD_H1, idxbar), yesterday_high);
      yesterday_low= MathMin(iLow(NULL, PERIOD_H1, idxbar), yesterday_low);
      
      // overwrite close in loop until we leave with the last bar's value
      yesterday_close= iClose(NULL, PERIOD_H1, idxbar);
   }


   if (tzdiff!=0 || TradingHoursFrom!=0 || TradingHoursTo!=24|| true) {
      double level= (yesterday_high + yesterday_low + yesterday_close) / 3;
      //SetTimeLine("YesterdayStart", "start", idxfirstbarofyesterday, CadetBlue, level - 4*Point);
      //SetTimeLine("YesterdayEnd", "end", idxlastbarofyesterday-1, CadetBlue, level - 4*Point);
   }
   
   today_open= iOpen(NULL, PERIOD_H1, idxfirstbaroftoday); // should be open of today start trading hour
   startofday= iTime(NULL, PERIOD_H1, idxfirstbaroftoday);

   // Print("Ybar= ", idxlastbarofyesterday, " tbar= ", idxfirstbaroftoday, "/", TimeToStr(startofday));
   
   day_high= -99999; // not high enough to remain alltime high
   day_low=  +99999; // not low enough to remain alltime low
   for (j= idxfirstbaroftoday; j>=0; j--) {
      day_high= MathMax(day_high, iHigh(NULL, PERIOD_H1, j));
      day_low= MathMin(day_low, iLow(NULL, PERIOD_H1, j));
   }
      
   
   //---- Calculate Levels
   
  
   
   D = (day_high - day_low);
   Q = (yesterday_high - yesterday_low);
   P = (yesterday_high + yesterday_low + yesterday_close) / 3;
   
   R1 = (2*P)-yesterday_low;
   R2 = P+(yesterday_high - yesterday_low);
	R3 = (2*P)+(yesterday_high-(2*yesterday_low));
   S1 = (2*P)-yesterday_high;
   S2 = P-(yesterday_high - yesterday_low);
	S3 = (2*P)-((2* yesterday_high)-yesterday_low);
	
	
	// END OF RICKY D SECTION
  
   
   levelGap = MinLevelGap * Point;
   
   int shift, lastbar, 
        swing_in= 30, // extra 30 bars for swing in
        counted_bars= IndicatorCounted();

   lastbar= MathMin(HistoryMax, Bars-AveragePeriod-swing_in-1);

   SetIndexDrawBegin(0, Bars-lastbar);   
   SetIndexDrawBegin(1, Bars-lastbar);

         
   double maxprice = 0;
   double minprice = 0;

    
   double oldmaxprice = 0;
   double oldminprice = 0;
  
  
   for (shift=0;  shift < BarsToProcess;  shift++) {
     maxprice = 0;
     minprice = 10000;
          
      for (j= shift+1; j <= shift + AveragePeriod ; j++) {
       maxprice= MathMax(maxprice, iHigh(Symbol(), Period(), j) );         
       minprice= MathMin(minprice, iLow(Symbol(), Period(), j));   
    }   
    //  Buffer2[shift]= maxprice + (Point * Pluspips); 
   //   Buffer1[shift]=  minprice -(Point * Pluspips);

      if (MathAbs(oldmaxprice - maxprice) > levelGap){
         if (NoSimiliarMaxLevels(maxprice) == true) {
            BufferMaxPrice[maxcount] = NormalizeDouble(maxprice,4);          
            maxcount ++;
          }
      }
     if (MathAbs(oldminprice - minprice) > levelGap){
     if (NoSimiliarMaxLevels(minprice) == true) {
          BufferMaxPrice[maxcount] = minprice;          
          maxprice ++;
          }
      }
      
      oldmaxprice = maxprice;
      oldminprice = minprice;
   }
  
   DrawSR();
      // one more thing to do is to derive the stop/resistance values from the arrays
   SetSR();
   
   writefile(day_high,day_low,yesterday_high,yesterday_open,yesterday_low,yesterday_close,today_open,today_high,today_low,R1,R2,R3,S1,S2,S3);
   return(0);
}


// we can also start to build our output array here
void DrawSR(){
int i;


//ArraySort(BufferMinPrice, WHOLE_ARRAY, 0,MODE_DESCEND);


for (i = 0;i <  maxcount; i++)  {
 string labeltext;
 if (BufferMaxPrice[i] > 0) {
      if (BufferMaxPrice[i] > Close[0]) {  
       SetLevel("resistance"+BufferMaxPrice[i], BufferMaxPrice[i] , Red, Time[0]);      
      }
      else
      {
       SetLevel("support"+BufferMaxPrice[i], BufferMaxPrice[i] , Blue, Time[0]);
      }   
   }
 }
}


// this function will pull out S1-3, R1-3 based on my system
void SetSR(){
   // so we need to find the closest to the current PRICE_CLOSE
   // already sorted ascending, so we are below the PRICE_CLOSE
  // ArraySort(BufferMaxPrice, MODE_ASCEND);
  double BufferSorted[100];
   int i;
   int dbnorm[100];
   double price = NormalizeDouble(iHigh(Symbol(), Period(),0),4);
  
   
    for (i = 0;i <  maxcount; i++)  {
         dbnorm[i] = MathRound(BufferMaxPrice[i]*10000);
   }
   ArraySort(dbnorm);
  // ArraySort(BufferMaxPrice);
   
   string convertaprice, newcovertprice;
   double dblconverted;
   
   for (i = 0;i <  ArraySize(dbnorm); i++)  {
    //  Print("dbnorm" + i + ":" + dbnorm[i]);
   //   BufferMaxPrice[i] = NormalizeDouble(dbnorm[i]/10000,10);   
     // Print("BufferMaxPrice" + i + ":" + BufferMaxPrice[i]); 
      
     convertaprice =  dbnorm[i];
     if (Symbol() == "USDJPY") {
     newcovertprice = StringSubstr(convertaprice,0,3) + "." + StringSubstr(convertaprice,3,2);  
     }
     else {
     newcovertprice = StringSubstr(convertaprice,0,1) + "." + StringSubstr(convertaprice,1,4);  
     }
     dblconverted = NormalizeDouble(StrToDouble(newcovertprice),5);
     BufferSorted[i] = dblconverted;
   //  Print(dblconverted);
   }
   
 //  Print("sorted list");
   
    for (i = 0;i <  ArraySize(dbnorm); i++)  {
  //      Print(BufferSorted[i]);
   }
   
  // Print((iHigh(Symbol(), Period(),0)));
      
   for (i = 0;i <  ArraySize(BufferSorted); i++)  {   
      if (BufferSorted[i] > (iHigh(Symbol(), Period(),0))) {  
      
     // if (BufferMaxPrice[i] > 0) {
       S3 = (BufferSorted[i-3]); 
     // }                       
       
      // if (BufferMaxPrice[i+1] > 0) {
       S2 = (BufferSorted[i-2]);
     //  }
       
      // if (BufferMaxPrice[i+2] > 0) {
       S1 = (BufferSorted[i-1]);
       SetTextLevel("S1", S1, Red, Time[0]);        
     //  }
       
     //  if (BufferMaxPrice[i-1] > 0) {
       R1 = (BufferSorted[i]);
       SetTextLevel("R1", R1 , Red, Time[0]); 
     //  }
       
      //  if (BufferMaxPrice[i-2] > 0) {
       R2 = (BufferSorted[i+1]);
     //  }
       
    //    if (BufferMaxPrice[i-3] > 0) {
       R3 = (BufferSorted[i+2]);       
    //   }
     //  Print("new values");
       
      // Print("R3="+R3);
      // Print("R2="+R2);
      // Print("R1="+R1);
      // Print("price:" + iHigh(Symbol(), Period(),0));
      // Print("S1="+S1);
      // Print("S2="+S2);
      // Print("S3="+S3);
       return;     
      }
   }
}


void SetTextLevel(string text, double level, color col1, datetime startofday)
{
   string labelname= "[PABPIVOT]" + text;
   int digits= MarketInfo(Symbol(), MODE_DIGITS);

   if (ObjectFind(labelname) != 0) {
      ObjectCreate(labelname, OBJ_TEXT, 0, MathMin(Time[0], startofday), level);
   }
   else {
      ObjectMove(labelname, 0, MathMin(Time[0], startofday), level);
   }
   ObjectSetText(labelname, " " + text + ": "+DoubleToStr(level, Digits), 8, "Arial", White);
   
}

void SetLevel(string text, double level, color col1, datetime startofday)
{
   string labelname= "[PABPIVOT] " + text + " Label";
   string linename= "[PABPIVOT] " + text + " Line";
   int digits= MarketInfo(Symbol(), MODE_DIGITS);

   if (ObjectFind(labelname) != 0) {
      ObjectCreate(labelname, OBJ_TEXT, 0, MathMin(Time[0], startofday), level);
   }
   else {
      ObjectMove(labelname, 0, MathMin(Time[0], startofday), level);
   }
   ObjectSetText(labelname, " " + text + ": "+DoubleToStr(level, Digits), 8, "Arial", White);
   
   if (ObjectFind(linename) != 0) {
      ObjectCreate(linename, OBJ_TREND, 0, startofday, level, Time[20],level);
      ObjectSet(linename, OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet(linename, OBJPROP_COLOR, col1);
   }
   else {
      ObjectMove(linename, 1, Time[20],level);
      ObjectMove(linename, 0, startofday, level);
   }
}

bool NoSimiliarMaxLevels(double maxprice){
bool retval = true;
int i;
for (i = 0;i <  maxcount; i++)  {   
       if (MathAbs(BufferMaxPrice[i]- maxprice) < (levelGap)) {
            retval = false;
     }
}
return(retval);
}




int writefile(double day_high,double  day_low,double  yesterday_high,double  yesterday_open,double  yesterday_low,double  yesterday_close,double  today_open,double  today_high,double  today_low,double  R1,double  R2,double  R3,double  S1,double  S2,double  S3) {           
if (Period() == 240)
{
      int handle;
      string filename, filetext;
      
            string SymbolText = Symbol();
      
      if (StringLen(SymbolText) == 7){ 
      SymbolText = StringSubstr(SymbolText, 0,6);
      }

    filetext = "Currency=" + SymbolText + ";Days High=" + day_high + ";Days Low=" + day_low + ";Yesterdays High=" + yesterday_high + ";Yesterdays Open=" + yesterday_open;
    filetext = filetext + ";Yesterdays Low="+yesterday_low + ";Yesterdays Close=" + yesterday_close + ";Todays Open=" + today_open;
    filetext = filetext +  ";Todays High=" + today_high + ";Todays Low=" + today_low + ";Resistance 3=" + R3 + ";Resistance 2=" + R2 + ";Resistance 1=" + R1 + ";Support 1=" + S1 + ";Support 2=" + S2 + ";Support 3=" + S3;
    filename = "dailypivots" + CurTime() + SymbolText;
       Print("Writing File : " + filename);
        
         handle=FileOpen(filename, FILE_CSV|FILE_WRITE, ';');
         
         if(handle>0)
         {  
           FileWrite(handle, filetext);
           FileClose(handle);
         }
         // post to alerts section for review   
   }
}