//+------------------------------------------------------------------+
//|                                           jaygalligher@yahoo.com |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 0
//---- input parameters
extern int SR_Tolerance=5;
extern bool Show_PsychLvls=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("CurYrH");
   ObjectDelete("CurYrL");
   ObjectDelete("PriorYrH");
   ObjectDelete("PriorYrL");
   ObjectDelete("CurMoH");
   ObjectDelete("CurMoL");
   ObjectDelete("PriorMoH");
   ObjectDelete("PriorMoL");
   ObjectDelete("CurWkH");
   ObjectDelete("CurWkL");
   ObjectDelete("PriorWkH");
   ObjectDelete("PriorWkL");
   ObjectDelete("PriorDayH");
   ObjectDelete("PriorDayL");
   ObjectDelete("PsychStrt");
   ObjectDelete("PsychPos1");
   ObjectDelete("PsychPos2");
   ObjectDelete("PsychPos3");
   ObjectDelete("PsychNeg1");
   ObjectDelete("PsychNeg2");
   ObjectDelete("PsychNeg3");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   ObjectDelete("CurYrH");
   ObjectDelete("CurYrL");
   ObjectDelete("PriorYrH");
   ObjectDelete("PriorYrL");
   ObjectDelete("CurMoH");
   ObjectDelete("CurMoL");
   ObjectDelete("PriorMoH");
   ObjectDelete("PriorMoL");
   ObjectDelete("CurWkH");
   ObjectDelete("CurWkL");
   ObjectDelete("PriorWkH");
   ObjectDelete("PriorWkL");
   ObjectDelete("PriorDayH");
   ObjectDelete("PriorDayL");
   ObjectDelete("PsychStrt");
   ObjectDelete("PsychPos1");
   ObjectDelete("PsychPos2");
   ObjectDelete("PsychPos3");
   ObjectDelete("PsychNeg1");
   ObjectDelete("PsychNeg2");
   ObjectDelete("PsychNeg3");

   int YR, cnt, CurYr=TimeYear(TimeCurrent());
   double Under=10000, Over=10000;
   double H, L, PSYCHSTRT, PSYCHPOS1, PSYCHPOS2, PSYCHPOS3, PSYCHNEG1, PSYCHNEG2, PSYCHNEG3;
   double FNLPSYCHSTRT, FNLPSYCHPOS1, FNLPSYCHPOS2, FNLPSYCHPOS3, FNLPSYCHNEG1, FNLPSYCHNEG2, FNLPSYCHNEG3;
   double CYH=0, PYH=0, CMH=0, PMH=0, CWH=0, PWH=0, CDH=0, PDH=0; 
   double CYL=1000, PYL=1000, CML=1000, PML=1000, CWL=1000, PWL=1000, CDL=1000, PDL=1000;

   if(Show_PsychLvls==true)
      {
   int PsyIncr=50;
   int STRT=MathRound(Close[0]/Point/100);
   PSYCHSTRT=STRT*Point*100;FNLPSYCHSTRT=PSYCHSTRT;
   PSYCHPOS1=PSYCHSTRT+PsyIncr*Point;FNLPSYCHPOS1=PSYCHPOS1;
   PSYCHPOS2=PSYCHPOS1+PsyIncr*Point;FNLPSYCHPOS2=PSYCHPOS2;
   PSYCHPOS3=PSYCHPOS2+PsyIncr*Point;FNLPSYCHPOS3=PSYCHPOS3;
   PSYCHNEG1=PSYCHSTRT-PsyIncr*Point;FNLPSYCHNEG1=PSYCHNEG1;
   PSYCHNEG2=PSYCHNEG1-PsyIncr*Point;FNLPSYCHNEG2=PSYCHNEG2;
   PSYCHNEG3=PSYCHNEG2-PsyIncr*Point;FNLPSYCHNEG3=PSYCHNEG3;
      }

   // *** Get Yearly and Monthly Highs/Lows from Monthly Data
   H=0;
   L=1000;
   for(cnt=24; cnt>=0; cnt--)
      {
      H=iHigh(NULL,43200,cnt);
      L=iLow(NULL,43200,cnt);
      YR=TimeYear(iTime(NULL,43200,cnt));
      if(YR==CurYr)
         {
         if(H>CYH) CYH=H;
         if(L<CYL) CYL=L;
         }
      if(YR==CurYr-1)
         {
         if(H>PYH) PYH=H;
         if(L<PYL) PYL=L;
         }
      if (cnt==0)
         {
         if(H > CMH) CMH = H;
         if(L < CML) CML = L;
         }
      if (cnt==1)
         {
         if(H > PMH) PMH = H;
         if(L < PML) PML = L;
         }
      }

   // *** Weekly Highs and Lows
      CWH=iHigh(NULL,10080,0);
      CWL=iLow(NULL,10080,0);
      PWH=iHigh(NULL,10080,1);
      PWL=iLow(NULL,10080,1);

   // *** Prior Day Highs and Lows
      PDH=iHigh(NULL,1440,1);
      PDL=iLow(NULL,1440,1);

   if(CYH<PSYCHPOS3+SR_Tolerance*Point && CYH>PSYCHPOS3-SR_Tolerance*Point) {CYH=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(CYH<PSYCHPOS2+SR_Tolerance*Point && CYH>PSYCHPOS2-SR_Tolerance*Point) {CYH=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(CYH<PSYCHPOS1+SR_Tolerance*Point && CYH>PSYCHPOS1-SR_Tolerance*Point) {CYH=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(CYH<PSYCHSTRT+SR_Tolerance*Point && CYH>PSYCHSTRT-SR_Tolerance*Point) {CYH=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(CYH<PSYCHNEG1+SR_Tolerance*Point && CYH>PSYCHNEG1-SR_Tolerance*Point) {CYH=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(CYH<PSYCHNEG2+SR_Tolerance*Point && CYH>PSYCHNEG2-SR_Tolerance*Point) {CYH=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(CYH<PSYCHNEG3+SR_Tolerance*Point && CYH>PSYCHNEG3-SR_Tolerance*Point) {CYH=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(CYL<PSYCHPOS3+SR_Tolerance*Point && CYL>PSYCHPOS3-SR_Tolerance*Point) {CYL=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(CYL<PSYCHPOS2+SR_Tolerance*Point && CYL>PSYCHPOS2-SR_Tolerance*Point) {CYL=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(CYL<PSYCHPOS1+SR_Tolerance*Point && CYL>PSYCHPOS1-SR_Tolerance*Point) {CYL=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(CYL<PSYCHSTRT+SR_Tolerance*Point && CYL>PSYCHSTRT-SR_Tolerance*Point) {CYL=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(CYL<PSYCHNEG1+SR_Tolerance*Point && CYL>PSYCHNEG1-SR_Tolerance*Point) {CYL=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(CYL<PSYCHNEG2+SR_Tolerance*Point && CYL>PSYCHNEG2-SR_Tolerance*Point) {CYL=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(CYL<PSYCHNEG3+SR_Tolerance*Point && CYL>PSYCHNEG3-SR_Tolerance*Point) {CYL=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PYH<PSYCHPOS3+SR_Tolerance*Point && PYH>PSYCHPOS3-SR_Tolerance*Point) {PYH=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(PYH<PSYCHPOS2+SR_Tolerance*Point && PYH>PSYCHPOS2-SR_Tolerance*Point) {PYH=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(PYH<PSYCHPOS1+SR_Tolerance*Point && PYH>PSYCHPOS1-SR_Tolerance*Point) {PYH=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(PYH<PSYCHSTRT+SR_Tolerance*Point && PYH>PSYCHSTRT-SR_Tolerance*Point) {PYH=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(PYH<PSYCHNEG1+SR_Tolerance*Point && PYH>PSYCHNEG1-SR_Tolerance*Point) {PYH=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(PYH<PSYCHNEG2+SR_Tolerance*Point && PYH>PSYCHNEG2-SR_Tolerance*Point) {PYH=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(PYH<PSYCHNEG3+SR_Tolerance*Point && PYH>PSYCHNEG3-SR_Tolerance*Point) {PYH=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PYL<PSYCHPOS3+SR_Tolerance*Point && PYL>PSYCHPOS3-SR_Tolerance*Point) {PYL=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(PYL<PSYCHPOS2+SR_Tolerance*Point && PYL>PSYCHPOS2-SR_Tolerance*Point) {PYL=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(PYL<PSYCHPOS1+SR_Tolerance*Point && PYL>PSYCHPOS1-SR_Tolerance*Point) {PYL=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(PYL<PSYCHSTRT+SR_Tolerance*Point && PYL>PSYCHSTRT-SR_Tolerance*Point) {PYL=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(PYL<PSYCHNEG1+SR_Tolerance*Point && PYL>PSYCHNEG1-SR_Tolerance*Point) {PYL=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(PYL<PSYCHNEG2+SR_Tolerance*Point && PYL>PSYCHNEG2-SR_Tolerance*Point) {PYL=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(PYL<PSYCHNEG3+SR_Tolerance*Point && PYL>PSYCHNEG3-SR_Tolerance*Point) {PYL=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(CMH<PSYCHPOS3+SR_Tolerance*Point && CMH>PSYCHPOS3-SR_Tolerance*Point) {CMH=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(CMH<PSYCHPOS2+SR_Tolerance*Point && CMH>PSYCHPOS2-SR_Tolerance*Point) {CMH=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(CMH<PSYCHPOS1+SR_Tolerance*Point && CMH>PSYCHPOS1-SR_Tolerance*Point) {CMH=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(CMH<PSYCHSTRT+SR_Tolerance*Point && CMH>PSYCHSTRT-SR_Tolerance*Point) {CMH=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(CMH<PSYCHNEG1+SR_Tolerance*Point && CMH>PSYCHNEG1-SR_Tolerance*Point) {CMH=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(CMH<PSYCHNEG2+SR_Tolerance*Point && CMH>PSYCHNEG2-SR_Tolerance*Point) {CMH=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(CMH<PSYCHNEG3+SR_Tolerance*Point && CMH>PSYCHNEG3-SR_Tolerance*Point) {CMH=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(CML<PSYCHPOS3+SR_Tolerance*Point && CML>PSYCHPOS3-SR_Tolerance*Point) {CML=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(CML<PSYCHPOS2+SR_Tolerance*Point && CML>PSYCHPOS2-SR_Tolerance*Point) {CML=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(CML<PSYCHPOS1+SR_Tolerance*Point && CML>PSYCHPOS1-SR_Tolerance*Point) {CML=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(CML<PSYCHSTRT+SR_Tolerance*Point && CML>PSYCHSTRT-SR_Tolerance*Point) {CML=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(CML<PSYCHNEG1+SR_Tolerance*Point && CML>PSYCHNEG1-SR_Tolerance*Point) {CML=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(CML<PSYCHNEG2+SR_Tolerance*Point && CML>PSYCHNEG2-SR_Tolerance*Point) {CML=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(CML<PSYCHNEG3+SR_Tolerance*Point && CML>PSYCHNEG3-SR_Tolerance*Point) {CML=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PMH<PSYCHPOS3+SR_Tolerance*Point && PMH>PSYCHPOS3-SR_Tolerance*Point) {PMH=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(PMH<PSYCHPOS2+SR_Tolerance*Point && PMH>PSYCHPOS2-SR_Tolerance*Point) {PMH=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(PMH<PSYCHPOS1+SR_Tolerance*Point && PMH>PSYCHPOS1-SR_Tolerance*Point) {PMH=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(PMH<PSYCHSTRT+SR_Tolerance*Point && PMH>PSYCHSTRT-SR_Tolerance*Point) {PMH=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(PMH<PSYCHNEG1+SR_Tolerance*Point && PMH>PSYCHNEG1-SR_Tolerance*Point) {PMH=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(PMH<PSYCHNEG2+SR_Tolerance*Point && PMH>PSYCHNEG2-SR_Tolerance*Point) {PMH=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(PMH<PSYCHNEG3+SR_Tolerance*Point && PMH>PSYCHNEG3-SR_Tolerance*Point) {PMH=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PML<PSYCHPOS3+SR_Tolerance*Point && PML>PSYCHPOS3-SR_Tolerance*Point) {PML=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(PML<PSYCHPOS2+SR_Tolerance*Point && PML>PSYCHPOS2-SR_Tolerance*Point) {PML=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(PML<PSYCHPOS1+SR_Tolerance*Point && PML>PSYCHPOS1-SR_Tolerance*Point) {PML=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(PML<PSYCHSTRT+SR_Tolerance*Point && PML>PSYCHSTRT-SR_Tolerance*Point) {PML=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(PML<PSYCHNEG1+SR_Tolerance*Point && PML>PSYCHNEG1-SR_Tolerance*Point) {PML=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(PML<PSYCHNEG2+SR_Tolerance*Point && PML>PSYCHNEG2-SR_Tolerance*Point) {PML=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(PML<PSYCHNEG3+SR_Tolerance*Point && PML>PSYCHNEG3-SR_Tolerance*Point) {PML=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(CWH<PSYCHPOS3+SR_Tolerance*Point && CWH>PSYCHPOS3-SR_Tolerance*Point) {CWH=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(CWH<PSYCHPOS2+SR_Tolerance*Point && CWH>PSYCHPOS2-SR_Tolerance*Point) {CWH=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(CWH<PSYCHPOS1+SR_Tolerance*Point && CWH>PSYCHPOS1-SR_Tolerance*Point) {CWH=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(CWH<PSYCHSTRT+SR_Tolerance*Point && CWH>PSYCHSTRT-SR_Tolerance*Point) {CWH=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(CWH<PSYCHNEG1+SR_Tolerance*Point && CWH>PSYCHNEG1-SR_Tolerance*Point) {CWH=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(CWH<PSYCHNEG2+SR_Tolerance*Point && CWH>PSYCHNEG2-SR_Tolerance*Point) {CWH=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(CWH<PSYCHNEG3+SR_Tolerance*Point && CWH>PSYCHNEG3-SR_Tolerance*Point) {CWH=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(CWL<PSYCHPOS3+SR_Tolerance*Point && CWL>PSYCHPOS3-SR_Tolerance*Point) {CWL=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(CWL<PSYCHPOS2+SR_Tolerance*Point && CWL>PSYCHPOS2-SR_Tolerance*Point) {CWL=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(CWL<PSYCHPOS1+SR_Tolerance*Point && CWL>PSYCHPOS1-SR_Tolerance*Point) {CWL=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(CWL<PSYCHSTRT+SR_Tolerance*Point && CWL>PSYCHSTRT-SR_Tolerance*Point) {CWL=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(CWL<PSYCHNEG1+SR_Tolerance*Point && CWL>PSYCHNEG1-SR_Tolerance*Point) {CWL=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(CWL<PSYCHNEG2+SR_Tolerance*Point && CWL>PSYCHNEG2-SR_Tolerance*Point) {CWL=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(CWL<PSYCHNEG3+SR_Tolerance*Point && CWL>PSYCHNEG3-SR_Tolerance*Point) {CWL=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PWH<PSYCHPOS3+SR_Tolerance*Point && PWH>PSYCHPOS3-SR_Tolerance*Point) {PWH=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(PWH<PSYCHPOS2+SR_Tolerance*Point && PWH>PSYCHPOS2-SR_Tolerance*Point) {PWH=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(PWH<PSYCHPOS1+SR_Tolerance*Point && PWH>PSYCHPOS1-SR_Tolerance*Point) {PWH=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(PWH<PSYCHSTRT+SR_Tolerance*Point && PWH>PSYCHSTRT-SR_Tolerance*Point) {PWH=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(PWH<PSYCHNEG1+SR_Tolerance*Point && PWH>PSYCHNEG1-SR_Tolerance*Point) {PWH=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(PWH<PSYCHNEG2+SR_Tolerance*Point && PWH>PSYCHNEG2-SR_Tolerance*Point) {PWH=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(PWH<PSYCHNEG3+SR_Tolerance*Point && PWH>PSYCHNEG3-SR_Tolerance*Point) {PWH=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PWL<PSYCHPOS3+SR_Tolerance*Point && PWL>PSYCHPOS3-SR_Tolerance*Point) {PWL=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(PWL<PSYCHPOS2+SR_Tolerance*Point && PWL>PSYCHPOS2-SR_Tolerance*Point) {PWL=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(PWL<PSYCHPOS1+SR_Tolerance*Point && PWL>PSYCHPOS1-SR_Tolerance*Point) {PWL=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(PWL<PSYCHSTRT+SR_Tolerance*Point && PWL>PSYCHSTRT-SR_Tolerance*Point) {PWL=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(PWL<PSYCHNEG1+SR_Tolerance*Point && PWL>PSYCHNEG1-SR_Tolerance*Point) {PWL=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(PWL<PSYCHNEG2+SR_Tolerance*Point && PWL>PSYCHNEG2-SR_Tolerance*Point) {PWL=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(PWL<PSYCHNEG3+SR_Tolerance*Point && PWL>PSYCHNEG3-SR_Tolerance*Point) {PWL=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PDH<PSYCHPOS3+SR_Tolerance*Point && PDH>PSYCHPOS3-SR_Tolerance*Point) {PDH=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(PDH<PSYCHPOS2+SR_Tolerance*Point && PDH>PSYCHPOS2-SR_Tolerance*Point) {PDH=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(PDH<PSYCHPOS1+SR_Tolerance*Point && PDH>PSYCHPOS1-SR_Tolerance*Point) {PDH=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(PDH<PSYCHSTRT+SR_Tolerance*Point && PDH>PSYCHSTRT-SR_Tolerance*Point) {PDH=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(PDH<PSYCHNEG1+SR_Tolerance*Point && PDH>PSYCHNEG1-SR_Tolerance*Point) {PDH=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(PDH<PSYCHNEG2+SR_Tolerance*Point && PDH>PSYCHNEG2-SR_Tolerance*Point) {PDH=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(PDH<PSYCHNEG3+SR_Tolerance*Point && PDH>PSYCHNEG3-SR_Tolerance*Point) {PDH=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PDL<PSYCHPOS3+SR_Tolerance*Point && PDL>PSYCHPOS3-SR_Tolerance*Point) {PDL=PSYCHPOS3; FNLPSYCHPOS3=0;}
   if(PDL<PSYCHPOS2+SR_Tolerance*Point && PDL>PSYCHPOS2-SR_Tolerance*Point) {PDL=PSYCHPOS2; FNLPSYCHPOS2=0;}
   if(PDL<PSYCHPOS1+SR_Tolerance*Point && PDL>PSYCHPOS1-SR_Tolerance*Point) {PDL=PSYCHPOS1; FNLPSYCHPOS1=0;}
   if(PDL<PSYCHSTRT+SR_Tolerance*Point && PDL>PSYCHSTRT-SR_Tolerance*Point) {PDL=PSYCHSTRT; FNLPSYCHSTRT=0;}
   if(PDL<PSYCHNEG1+SR_Tolerance*Point && PDL>PSYCHNEG1-SR_Tolerance*Point) {PDL=PSYCHNEG1; FNLPSYCHNEG1=0;}
   if(PDL<PSYCHNEG2+SR_Tolerance*Point && PDL>PSYCHNEG2-SR_Tolerance*Point) {PDL=PSYCHNEG2; FNLPSYCHNEG2=0;}
   if(PDL<PSYCHNEG3+SR_Tolerance*Point && PDL>PSYCHNEG3-SR_Tolerance*Point) {PDL=PSYCHNEG3; FNLPSYCHNEG3=0;}

   if(PYH==CYH || PYH==CYL) PYH=0;
   if(PYL==CYH || PYL==CYL) PYL=0;
   if(CMH==CYH || CMH==CYL || CMH==PYH || CMH==PYL) CMH=0;
   if(CML==CYH || CML==CYL || CML==PYH || CML==PYL) CML=0;
   if(PMH==CYH || PMH==CYL || PMH==PYH || PMH==PYL || PMH==CMH || PMH==CML) PMH=0;
   if(PML==CYH || PML==CYL || PML==PYH || PML==PYL || PML==CMH || PML==CML) PML=0;
   if(CWH==CYH || CWH==CYL || CWH==PYH || CWH==PYL || CWH==CMH || CWH==CML || CWH==PMH || CWH==PML) CWH=0;
   if(CWL==CYH || CWL==CYL || CWL==PYH || CWL==PYL || CWL==CMH || CWL==CML || CWL==PMH || CWL==PML) CWL=0;
   if(PWH==CYH || PWH==CYL || PWH==PYH || PWH==PYL || PWH==CMH || PWH==CML || PWH==PMH || PWH==PML || PWH==CWH || PWH==CWL) PWH=0;
   if(PWL==CYH || PWL==CYL || PWL==PYH || PWL==PYL || PWL==CMH || PWL==CML || PWL==PMH || PWL==PML || PWL==CWH || PWL==CWL) PWL=0;
   if(PDH==CYH || PDH==CYL || PDH==PYH || PDH==PYL || PDH==CMH || PDH==CML || PDH==PMH || PDH==PML || PDH==CWH || PDH==CWL || PDH==PWH || PDH==PWL) PDH=0;
   if(PDL==CYH || PDL==CYL || PDL==PYH || PDL==PYL || PDL==CMH || PDL==CML || PDL==PMH || PDL==PML || PDL==CWH || PDL==CWL || PDL==PWH || PDL==PWL) PDL=0;

   if(FNLPSYCHSTRT>Close[0] && (FNLPSYCHSTRT-Close[0])/Point<Over) Over = (FNLPSYCHSTRT-Close[0])/Point;
   if(FNLPSYCHSTRT<=Close[0] && (Close[0]-FNLPSYCHSTRT)/Point<Under) Under = (Close[0]-FNLPSYCHSTRT)/Point;
   ObjectCreate("PsychStrt", OBJ_HLINE, 0, 0, FNLPSYCHSTRT);
   ObjectSet("PsychStrt", OBJPROP_COLOR, Blue);
   ObjectSet("PsychStrt", OBJPROP_WIDTH, 1);

   if(FNLPSYCHPOS1>Close[0] && (FNLPSYCHPOS1-Close[0])/Point<Over) Over = (FNLPSYCHPOS1-Close[0])/Point;
   if(FNLPSYCHPOS1<=Close[0] && (Close[0]-FNLPSYCHPOS1)/Point<Under) Under = (Close[0]-FNLPSYCHPOS1)/Point;
   ObjectCreate("PsychPos1", OBJ_HLINE, 0, 0, FNLPSYCHPOS1);
   ObjectSet("PsychPos1", OBJPROP_COLOR, Blue);
   ObjectSet("PsychPos1", OBJPROP_WIDTH, 1);

   if(FNLPSYCHPOS2>Close[0] && (FNLPSYCHPOS2-Close[0])/Point<Over) Over = (FNLPSYCHPOS2-Close[0])/Point;
   if(FNLPSYCHPOS2<=Close[0] && (Close[0]-FNLPSYCHPOS2)/Point<Under) Under = (Close[0]-FNLPSYCHPOS2)/Point;
   ObjectCreate("PsychPos2", OBJ_HLINE, 0, 0, FNLPSYCHPOS2);
   ObjectSet("PsychPos2", OBJPROP_COLOR, Blue);
   ObjectSet("PsychPos2", OBJPROP_WIDTH, 1);

   if(FNLPSYCHPOS3>Close[0] && (FNLPSYCHPOS3-Close[0])/Point<Over) Over = (FNLPSYCHPOS3-Close[0])/Point;
   if(FNLPSYCHPOS3<=Close[0] && (Close[0]-FNLPSYCHPOS3)/Point<Under) Under = (Close[0]-FNLPSYCHPOS3)/Point;
   ObjectCreate("PsychPos3", OBJ_HLINE, 0, 0, FNLPSYCHPOS3);
   ObjectSet("PsychPos3", OBJPROP_COLOR, Blue);
   ObjectSet("PsychPos3", OBJPROP_WIDTH, 1);

   if(FNLPSYCHNEG1>Close[0] && (FNLPSYCHNEG1-Close[0])/Point<Over) Over = (FNLPSYCHNEG1-Close[0])/Point;
   if(FNLPSYCHNEG1<=Close[0] && (Close[0]-FNLPSYCHNEG1)/Point<Under) Under = (Close[0]-FNLPSYCHNEG1)/Point;
   ObjectCreate("PsychNeg1", OBJ_HLINE, 0, 0, FNLPSYCHNEG1);
   ObjectSet("PsychNeg1", OBJPROP_COLOR, Blue);
   ObjectSet("PsychNeg1", OBJPROP_WIDTH, 1);

   if(FNLPSYCHNEG2>Close[0] && (FNLPSYCHNEG2-Close[0])/Point<Over) Over = (FNLPSYCHNEG2-Close[0])/Point;
   if(FNLPSYCHNEG2<=Close[0] && (Close[0]-FNLPSYCHNEG2)/Point<Under) Under = (Close[0]-FNLPSYCHNEG2)/Point;
   ObjectCreate("PsychNeg2", OBJ_HLINE, 0, 0, FNLPSYCHNEG2);
   ObjectSet("PsychNeg2", OBJPROP_COLOR, Blue);
   ObjectSet("PsychNeg2", OBJPROP_WIDTH, 1);

   if(FNLPSYCHNEG3>Close[0] && (FNLPSYCHNEG3-Close[0])/Point<Over) Over = (FNLPSYCHNEG3-Close[0])/Point;
   if(FNLPSYCHNEG3<=Close[0] && (Close[0]-FNLPSYCHNEG3)/Point<Under) Under = (Close[0]-FNLPSYCHNEG3)/Point;
   ObjectCreate("PsychNeg3", OBJ_HLINE, 0, 0, FNLPSYCHNEG3);
   ObjectSet("PsychNeg3", OBJPROP_COLOR, Blue);
   ObjectSet("PsychNeg3", OBJPROP_WIDTH, 1);

   if(CYH>Close[0] && (CYH-Close[0])/Point<Over) Over = (CYH-Close[0])/Point;
   if(CYH<=Close[0] && (Close[0]-CYH)/Point<Under) Under = (Close[0]-CYH)/Point;
   ObjectCreate("CurYrH", OBJ_HLINE, 0, 0, CYH);
   ObjectSet("CurYrH", OBJPROP_COLOR, Yellow);
   ObjectSet("CurYrH", OBJPROP_WIDTH, 2);

   if(CYL>Close[0] && (CYL-Close[0])/Point<Over) Over = (CYL-Close[0])/Point;
   if(CYL<=Close[0] && (Close[0]-CYL)/Point<Under) Under = (Close[0]-CYL)/Point;
   ObjectCreate("CurYrL", OBJ_HLINE, 0, 0, CYL);
   ObjectSet("CurYrL", OBJPROP_COLOR, Yellow);
   ObjectSet("CurYrL", OBJPROP_WIDTH, 2);

   if(PYH>Close[0] && (PYH-Close[0])/Point<Over) Over = (PYH-Close[0])/Point;
   if(PYH<=Close[0] && (Close[0]-PYH)/Point<Under) Under = (Close[0]-PYH)/Point;
   ObjectCreate("PriorYrH", OBJ_HLINE, 0, 0, PYH);
   ObjectSet("PriorYrH", OBJPROP_COLOR, Yellow);
   ObjectSet("PriorYrH", OBJPROP_WIDTH, 1);

   if(PYL>Close[0] && (PYL-Close[0])/Point<Over) Over = (PYL-Close[0])/Point;
   if(PYL<=Close[0] && (Close[0]-PYL)/Point<Under) Under = (Close[0]-PYL)/Point;
   ObjectCreate("PriorYrL", OBJ_HLINE, 0, 0, PYL);
   ObjectSet("PriorYrL", OBJPROP_COLOR, Yellow);
   ObjectSet("PriorYrL", OBJPROP_WIDTH, 1);

   if(CMH>Close[0] && (CMH-Close[0])/Point<Over) Over = (CMH-Close[0])/Point;
   if(CMH<=Close[0] && (Close[0]-CMH)/Point<Under) Under = (Close[0]-CMH)/Point;
   ObjectCreate("CurMoH", OBJ_HLINE, 0, 0, CMH);
   ObjectSet("CurMoH", OBJPROP_COLOR, Red);
   ObjectSet("CurMoH", OBJPROP_WIDTH, 2);

   if(CML>Close[0] && (CML-Close[0])/Point<Over) Over = (CML-Close[0])/Point;
   if(CML<=Close[0] && (Close[0]-CML)/Point<Under) Under = (Close[0]-CML)/Point;
   ObjectCreate("CurMoL", OBJ_HLINE, 0, 0, CML);
   ObjectSet("CurMoL", OBJPROP_COLOR, Red);
   ObjectSet("CurMoL", OBJPROP_WIDTH, 2);

   if(PMH>Close[0] && (PMH-Close[0])/Point<Over) Over = (PMH-Close[0])/Point;
   if(PMH<=Close[0] && (Close[0]-PMH)/Point<Under) Under = (Close[0]-PMH)/Point;
   ObjectCreate("PriorMoH", OBJ_HLINE, 0, 0, PMH);
   ObjectSet("PriorMoH", OBJPROP_COLOR, Red);
   ObjectSet("PriorMoH", OBJPROP_WIDTH, 1);

   if(PML>Close[0] && (PML-Close[0])/Point<Over) Over = (PML-Close[0])/Point;
   if(PML<=Close[0] && (Close[0]-PML)/Point<Under) Under = (Close[0]-PML)/Point;
   ObjectCreate("PriorMoL", OBJ_HLINE, 0, 0, PML);
   ObjectSet("PriorMoL", OBJPROP_COLOR, Red);
   ObjectSet("PriorMoL", OBJPROP_WIDTH, 1);

   if(CWH>Close[0] && (CWH-Close[0])/Point<Over) Over = (CWH-Close[0])/Point;
   if(CWH<=Close[0] && (Close[0]-CWH)/Point<Under) Under = (Close[0]-CWH)/Point;
   ObjectCreate("CurWkH", OBJ_HLINE, 0, 0, CWH);
   ObjectSet("CurWkH", OBJPROP_COLOR, Magenta);
   ObjectSet("CurWkH", OBJPROP_WIDTH, 2);

   if(CWL>Close[0] && (CWL-Close[0])/Point<Over) Over = (CWL-Close[0])/Point;
   if(CWL<=Close[0] && (Close[0]-CWL)/Point<Under) Under = (Close[0]-CWL)/Point;
   ObjectCreate("CurWkL", OBJ_HLINE, 0, 0, CWL);
   ObjectSet("CurWkL", OBJPROP_COLOR, Magenta);
   ObjectSet("CurWkL", OBJPROP_WIDTH, 2);

   if(PWH>Close[0] && (PWH-Close[0])/Point<Over) Over = (PWH-Close[0])/Point;
   if(PWH<=Close[0] && (Close[0]-PWH)/Point<Under) Under = (Close[0]-PWH)/Point;
   ObjectCreate("PriorWkH", OBJ_HLINE, 0, 0, PWH);
   ObjectSet("PriorWkH", OBJPROP_COLOR, Magenta);
   ObjectSet("PriorWkH", OBJPROP_WIDTH, 1);

   if(PWL>Close[0] && (PWL-Close[0])/Point<Over) Over = (PWL-Close[0])/Point;
   if(PWL<=Close[0] && (Close[0]-PWL)/Point<Under) Under = (Close[0]-PWL)/Point;
   ObjectCreate("PriorWkL", OBJ_HLINE, 0, 0, PWL);
   ObjectSet("PriorWkL", OBJPROP_COLOR, Magenta);
   ObjectSet("PriorWkL", OBJPROP_WIDTH, 1);

   if(PDH>Close[0] && (PDH-Close[0])/Point<Over) Over = (PDH-Close[0])/Point;
   if(PDH<=Close[0] && (Close[0]-PDH)/Point<Under) Under = (Close[0]-PDH)/Point;
   ObjectCreate("PriorDayH", OBJ_HLINE, 0, 0, PDH);
   ObjectSet("PriorDayH", OBJPROP_COLOR, Plum);
   ObjectSet("PriorDayH", OBJPROP_WIDTH, 1);

   if(PDL>Close[0] && (PDL-Close[0])/Point<Over) Over = (PDL-Close[0])/Point;
   if(PDL<=Close[0] && (Close[0]-PDL)/Point<Under) Under = (Close[0]-PDL)/Point;
   ObjectCreate("PriorDayL", OBJ_HLINE, 0, 0, PDL);
   ObjectSet("PriorDayL", OBJPROP_COLOR, Plum);
   ObjectSet("PriorDayL", OBJPROP_WIDTH, 1);
//---- force objects drawing
   ObjectsRedraw();
//----
   return(0);
  }
//+------------------------------------------------------------------+

