//+------------------------------------------------------------------+
//|                                                        SR_v3.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
//daily
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

extern int barSize = 1;
extern int yellowStep = 5;
extern int LStep = 3;
#property indicator_chart_window
int one_day_bars,max;
double levels[1];
double res[1];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
 
int init()
  {
//---- indicators
//int daily_bars = iBarShift(Symbol(),30,iTime(Symbol(),PERIOD_D1,0),false); 
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i= one_day_bars;i>=0;i--) ObjectDelete("r"+i);
   for(int j= max;j>=0;j--) ObjectDelete("vLine_"+j);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
double step = (LStep*Point);
one_day_bars = iBarShift(Symbol(),30,CurTime()-(60*60*24),false); 
max = 0;

   double upBound = High[Highest(Symbol(),0,MODE_HIGH,one_day_bars,0)];
   double lowBound = Low[Lowest(Symbol(),0,MODE_LOW,one_day_bars,0)];
 
   int lCount = (upBound-lowBound)/step;
   
   ArrayResize(levels,lCount+1);
   ArrayResize(res,lCount+1);
   
   for(int a=1;a<=lCount;a++)
   {
       levels[a] = lowBound+(step*a);
       res[a] = 0;
   }
   
   for(int b=one_day_bars-1;b>=0;b--)
   {   
      for(int u=1;u<=lCount;u++)
      {
         if( (High[b]>=levels[u] && Low[b]< levels[u-1]) || (Low[b] < levels[u] && Low[b] >= levels[u-1]) || (High[b] < levels[u] && High[b] >= levels[u-1]) )   
         {
         
            res[u] = res[u]+1;
         }
      }
   }
   
   for(int r=1;r<=lCount;r++)
   {
     line(levels[r],"r"+r,DarkOrchid,res[r] ); 
   }
   
   ArraySort(res,WHOLE_ARRAY,0,MODE_ASCEND);
   max = res[ArraySize(res)-1];
   
   for(int m = yellowStep;m < max;m+=yellowStep)
   {
      vline(levels[1],levels[lCount] ,Time[m],"vLine_"+m,Yellow);
   }
   

//----
   return(0);
  }
//+------------------------------------------------------------------+
void line(double lvl,string name, color Col, int width)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, Time[width], lvl,Time[0],lvl);
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,barSize);
            ObjectSet(name,OBJPROP_RAY,0);         
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, Time[width], lvl,Time[0],lvl);
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,barSize);
            ObjectSet(name,OBJPROP_RAY,0);
         }
}

void vline(double top,double bottom ,int time,string name, color Col)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, time, top,time,bottom);
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,barSize);
            ObjectSet(name,OBJPROP_RAY,0);         
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, time, top,time,bottom);
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,barSize);
            ObjectSet(name,OBJPROP_RAY,0);
         }
}

