//+------------------------------------------------------------------+
//|                                                       SwissCheese |
//|                                     Copyright  2006, Paul@easyforexsignals.com |
//+------------------------------------------------------------------+

//---- input parameters
extern int       Start1=8;           //begin of the first session; time adjust by your broker time
extern int       DeleteTime=12;           //begin of the first session; time adjust by your broker time
extern int       Length=18;            //length of range for determining high/low
extern int       Pips=15;              //trigger above/bellow range
extern int       StopLoss=30;
extern int       BreakEven=20;
extern int       TrailingStop=0;     
extern int       TakeProfit=40;
extern double    Lots=1;

int MN = 23423432;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   //---- 
   int i,Ticket;
   
   
   
   //Setup comment
   string Text="SwissCheese"+Symbol();

   //Setup orders
   if(Hour()==Start1 && Minute()<2){
      SetOrders(Text,MN);
   }
   
   
   if(Hour()==DeleteTime && Minute()<5){
       DeleteOrders(Text,MN);
      CloseExisting();
   }
    
   //Manage open orders
   for (i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==MN){
         //close open positions at EOD

            //move at BE if profit>BE
            if(TrailingStop==0){ 
               if(OrderType()==OP_BUY){
                  if(High[0]-OrderOpenPrice()>=BreakEven*Point && OrderStopLoss()<OrderOpenPrice()){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
                     Sleep(10000);
                  }   
               }   
               if(OrderType()==OP_SELL){
                  if(OrderOpenPrice()-Low[0]>=BreakEven*Point && OrderStopLoss()>OrderOpenPrice()){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
                     Sleep(10000);
                  }
               }
            }
            //use trailing stop
            else {                  
               if(OrderType()==OP_BUY){
                  if(High[0]-OrderStopLoss()>=(StopLoss+TrailingStop)*Point){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()+TrailingStop*Point,OrderTakeProfit(),0,Green);
                     Sleep(10000);
                  }   
               }   
               if(OrderType()==OP_SELL){
                  if(OrderStopLoss()-Low[0]>=(StopLoss+TrailingStop)*Point){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-TrailingStop*Point,OrderTakeProfit(),0,Green);
                     Sleep(10000);
                  }
               }
           
         }
      }
   }
   
   return(0);
   }
//+------------------------------------------------------------------+

void SetOrders(string Text,int MN){
   int i,Ticket,Bought,Sold;
   double EntryLong,EntryShort,SLLong,SLShort,TPLong,TPShort;

   //Determine range
   EntryShort   =iHigh(NULL,60,Highest(NULL,60,MODE_HIGH,Length,1))-(Pips)*Point;
   EntryLong  =iLow (NULL,60,Lowest (NULL,60,MODE_LOW, Length,1))+Pips*Point;
   SLLong      = EntryLong-(StopLoss*Point);//MathMax(EntryLong-StopLoss*Point,EntryShort);
   SLShort     =EntryShort+(StopLoss*Point);//MathMin(EntryShort+StopLoss*Point,EntryLong);
   TPLong      =EntryLong+(TakeProfit*Point);
   TPShort     =EntryShort-(TakeProfit*Point);
   
   
   
      for (i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==MN){
         if(OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT ) Bought++;
         if(OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT) Sold++;
      }
   }
  
  if((Bought==0) ){ //no buy order
    Ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,EntryLong,10,SLLong,TPLong,Text,MN,0,Green);
     if(Ticket<0 && GetLastError()==130)
         Ticket=OrderSend(Symbol(),OP_BUYLIMIT,Lots,EntryLong,10,SLLong,TPLong,Text,MN,0,Green);
 
  }
   

 if((Sold==0)){ //no sell order
Ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,EntryShort,10,SLShort,TPShort,Text,MN,0,Green);
     if(Ticket<0 && GetLastError()==130)
         Ticket=OrderSend(Symbol(),OP_SELLLIMIT,Lots,EntryShort,10,SLShort,TPShort,Text,MN,0,Green);
   }
 
}


void DeleteOrders(string Text,int MN){
int i;
   for (i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderComment()==Text && OrderMagicNumber()==MN){
         if(OrderType()==OP_BUYSTOP ) OrderDelete(OrderTicket());
         if(OrderType()==OP_SELLSTOP )OrderDelete(OrderTicket());
      }
   }
}

  void CloseExisting()
  {
  

//---- go trading only for first tiks of new bar
//---- get Moving Average 
   //----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MN || OrderSymbol()!=Symbol()) continue;
      //---- just close it
    
          if(OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
            {
               OrderDelete(OrderTicket());         
            }
          else  if(OrderType()==OP_BUYSTOP  || OrderType()==OP_BUYLIMIT)
            {
               OrderDelete(OrderTicket());         
            }
                  
     }
  }