// Trend Manager.mq4
// Based on indicator sold at traderstradingsystem.com
// extended by www.easyforexsignals.com - check for more indicators on the site
// to include filters for solar wind, juice, adx

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern int TM_Period = 500;


double BufferBuySignals[];
double BufferSellSignals[];

int a_begin;

int init()
{
  // a_begin=TM_Shift;
     
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,BufferBuySignals);
    
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,BufferSellSignals);
   
   IndicatorShortName("TRIGGERCONFIRM");
   
   string SymbolText = Symbol();      
   if (StringLen(SymbolText) == 7){ 
      SymbolText = StringSubstr(SymbolText, 0,6);
   }
      
   
   return(0);
}

int start()
{
   int    i,k, power;
   int    counted_bars=IndicatorCounted();
   double high,low,price;

   if(Bars<=TM_Period) return(0);
   if(counted_bars<1)
   {
      for(i=1;i<=TM_Period;i++) 
      {
         BufferBuySignals[Bars-i]=0;
         BufferSellSignals[Bars-i]=0;
      }
   }

   i=Bars-TM_Period;
   if(counted_bars>TM_Period) i=Bars-counted_bars-1;
   while(i>=0)
   {
      BufferBuySignals[i]=0;
      BufferSellSignals[i]=0;
      
      BufferBuySignals[i]=CheckALL(i, OP_BUY);               
      BufferSellSignals[i]=CheckALL(i, OP_SELL);
      
    //  if (0-BufferSellSignals[i] > BufferBuySignals[i])
    //  {BufferBuySignals[i]=0;}
    //  else
    //  {BufferSellSignals[i]=0;}

    i--;
   }
   return(0);
}

int CheckALL(int i, int OrderTyp) {

int retval = 0;

i = i * Period()/60;

 if (OrderTyp == OP_BUY)
    {

      if (CheckTrigger(60, i, OP_BUY)==true )//&& CheckTrigger(1440, usebar, OP_BUY))
      {
         retval++;
      }
      
      if (CheckTrigger(240, i/4, OP_BUY)==true )//&& CheckTrigger(1440, usebar, OP_BUY))
      {
         retval++;
      }
      if (CheckTrigger(1440, i/24, OP_BUY)==true )//&& CheckTrigger(1440, usebar, OP_BUY))
      {
         retval++;
      }
      if (CheckTrigger(10080, i/168, OP_BUY)==true )//&& CheckTrigger(1440, usebar, OP_BUY))
      {
         retval++;
      }
   }
   else
   if (OrderTyp == OP_SELL)
   {

    if (CheckTrigger(60, i, OP_SELL)==true )//&& CheckTrigger(1440, usebar, OP_BUY))
      {
         retval--;
      }
     
    if (CheckTrigger(240, i/4, OP_SELL)==true )//&& CheckTrigger(1440, usebar, OP_BUY))
      {
         retval--;
      }
    if (CheckTrigger(1440, i/24, OP_SELL)==true )//&& CheckTrigger(1440, usebar, OP_BUY))
      {
         retval--;
      }
      if (CheckTrigger(10080, i/168, OP_SELL)==true )//&& CheckTrigger(1440, usebar, OP_BUY))
      {
         retval--;
      }
      

   }
return(retval);
}

// check all filters here, not just adx
bool CheckTrigger(int usePeriod, int i, int OrderTyp) {
 bool retval = false;
   
 // get the WindowFind


  double TriggerSellD = iCustom(Symbol(),usePeriod, "TriggerLines",0, i);
  double TriggerSellD2 = iCustom(Symbol(),usePeriod, "TriggerLines",1, i);
  double TriggerBuyD = iCustom(Symbol(),usePeriod, "TriggerLines",2, i);
  double TriggerBuyD2 = iCustom(Symbol(),usePeriod, "TriggerLines",3, i);
  
   if (OrderTyp == OP_BUY)
    {
        if ((TriggerSellD2 < TriggerSellD) )
        {retval = true;}
     }
     else if (OrderTyp == OP_SELL) 
     {
        if ((TriggerSellD2 > TriggerSellD) )
        {retval = true;}
     }
      
   return(retval);
}