#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Blue


#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2

extern int TM_Period = 7;
extern int TM_Shift = 2;
extern int MaxADX = 45;

// USDJPY 30, usdchf 48 eurus 42, eurjpy 40
extern int MinADX = 22;
extern int MinRisingADX = 17;
extern int MoveArrowFromCandleInPoints = 10;
extern bool risingADXoverrides = true;
extern bool confirmondaily = false;
extern bool UseNewTrend = true;
extern bool SWConfirm = false;
extern bool ema50confirm = false;
extern int NTMinGap = 5;
extern int MinBarLengthInPoints = 5;
extern int TradeOrderOffset = 25;


double SpanA_Buffer[];
double SpanB_Buffer[];

double BufferBuySignals[];
double BufferSellSignals[];

double BufferFinalBuySignals[];
double BufferFinalSellSignals[];

int a_begin;

int init()
{
   a_begin=TM_Shift;
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(0,SpanB_Buffer);
   SetIndexDrawBegin(0,TM_Period+a_begin-1);
   SetIndexLabel(0,"TM_Period+");
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,SpanA_Buffer);
   SetIndexDrawBegin(1,TM_Period+a_begin-1);
   SetIndexLabel(1,"TM_Period");
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexBuffer(2,BufferBuySignals);
   SetIndexArrow(2,233); 
   SetIndexLabel(2,"BUY");
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3,BufferSellSignals);
   SetIndexArrow(3,234); 
   SetIndexLabel(3,"SELL");
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexBuffer(4,BufferFinalBuySignals);
   SetIndexArrow(4,217); 
   SetIndexLabel(4,"CLOSE");
   
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexBuffer(5,BufferFinalSellSignals);
   SetIndexArrow(5,218); 
   SetIndexLabel(5,"CLOSE");

   IndicatorShortName("TRENDMGRNT");
   
   string SymbolText = Symbol();      
   if (StringLen(SymbolText) == 7){ 
      SymbolText = StringSubstr(SymbolText, 0,6);
   }
        
   return(0);
}

int start()
{
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;

   if(Bars<=TM_Period) return(0);
   if(counted_bars<1)
   {
      for(i=1;i<=TM_Period;i++) 
      {
         SpanA_Buffer[Bars-i]=0;
         SpanB_Buffer[Bars-i]=0;
         BufferBuySignals[Bars-i]=0;
         BufferSellSignals[Bars-i]=0;
         BufferFinalBuySignals[Bars-i]=0;
         BufferFinalSellSignals[Bars-i]=0;         
      }
   }

   i=Bars-TM_Period;
   if(counted_bars>TM_Period) i=Bars-counted_bars-1;
   while(i>=0)
   {
      high=High[i]; low=Low[i]; k=i-1+TM_Period;
      while(k>=i)
      {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
      }
      SpanA_Buffer[i]  = (high+low)/2.0;
      SpanB_Buffer[i]  = SpanA_Buffer[i+TM_Shift];
      BufferBuySignals[i]=0;
      BufferSellSignals[i]=0;
      BufferFinalBuySignals[i]=0;
      BufferFinalSellSignals[i]=0;
      

      if (CheckClose(i, OP_BUY)==true) {
           BufferFinalBuySignals[i]=Low[i+1]+Point*(TradeOrderOffset);
       }
       if (CheckClose(i, OP_SELL)==true) {
           BufferFinalSellSignals[i]=High[i+1]-Point*(TradeOrderOffset);
       }
       
      
      if (SpanA_Buffer[i] !=  SpanB_Buffer[i]) {
      

         if ((SpanA_Buffer[i] >  SpanB_Buffer[i]) && (SpanA_Buffer[i+1] <=  SpanB_Buffer[i+1])) {
            if (CheckAdx(i, OP_BUY)==true) {
               if ((MinBarLengthInPoints * Point) < (SpanA_Buffer[i] - SpanB_Buffer[i]))            
               {
                  BufferBuySignals[i]=Low[i]-Point*MoveArrowFromCandleInPoints;
                  if (i == 1) {               
                    //Alert("Buy on TM on " + Symbol());
                  }
             //     Print(SpanA_Buffer[i] - SpanB_Buffer[i]);
               }
            }
            else
            {
             BufferBuySignals[i]=0;
            }
         }
         else   if ((SpanA_Buffer[i] <  SpanB_Buffer[i]) && (SpanA_Buffer[i+1] >=  SpanB_Buffer[i+1])) {
            if (CheckAdx(i, OP_SELL)==true) {
                if ((MinBarLengthInPoints * Point) < (SpanB_Buffer[i] - SpanA_Buffer[i]))            
               {
                BufferSellSignals[i]=High[i]+Point*MoveArrowFromCandleInPoints;
                if (i == 1) {
                   //Alert("Sell on TM" + Symbol());
                }
              //  Print(SpanB_Buffer[i] - SpanA_Buffer[i] + ":" + (MinBarLengthInPoints * Point));
                }
            }
            else{
            BufferSellSignals[i]=0;
            }
         }
      }
      i--;
   }

   return(0);
}



//actually checks for real signals, just as a test
bool CheckClose(int i, int OrderTyp) {
bool retval = false;
 //  retval = CheckAdx(i, OrderTyp);
 if (OrderTyp == OP_BUY) {
   if ((BufferBuySignals[i+1] > 0) && (Low[i] <= Low[i+1]+(TradeOrderOffset*Point)))
   {retval=true;} 
 }
 
 if (OrderTyp == OP_SELL) {
   if ((BufferSellSignals[i+1] > 0) && (High[i] >= High[i+1]-(TradeOrderOffset*Point)))
   {retval=true;} 
 }
 
  return(retval);
 }

// check all filters here, not just adx
bool CheckAdx(int i, int OrderTyp) {
 bool retval = false;
   

 
 double adx = iADX(Symbol(),Period(), 14, PRICE_CLOSE, MODE_MAIN,i);
 double adxold = iADX(Symbol(),Period(), 14, PRICE_CLOSE, MODE_MAIN,i+1);
 bool adxvalid = false;
 
 
 if (risingADXoverrides ==true)
  {
      if (adxold < adx) // rising
         {
         if  (adx > MinRisingADX)
            {  adxvalid = true;}
         }
      else //falling
         {
         if  (adx > MinADX)
            {  adxvalid = true;}
         }
     
  }
  else
  {
   if (adx >= MinADX) {
      adxvalid = true;
   }   
  }
 
 if (adx > MaxADX) {adxvalid = false;}
   
 double TriggerSell = iCustom(Symbol(),Period(), "TriggerLines",0, i);
 double TriggerSell2 = iCustom(Symbol(),Period(), "TriggerLines",1, i);
 
 double TriggerBuy = iCustom(Symbol(),Period(), "TriggerLines",2, i);
 double TriggerBuy2 = iCustom(Symbol(),Period(), "TriggerLines",3, i);
 
    if (OrderTyp == OP_BUY)
    {
        if ((TriggerBuy2 < TriggerBuy) && (adxvalid == true))
        {retval = true;}
        else
        {retval = false;}
     }
     else if (OrderTyp == OP_SELL) 
     {
        if ((TriggerSell2 > TriggerSell) && (adxvalid == true))
        {retval = true;}
        else
        {retval = false;}
     }
  
  if ((retval==true) && (confirmondaily==true))
  {
  double TriggerSellD = iCustom(Symbol(),1440, "TriggerLines",0, i);
  double TriggerSellD2 = iCustom(Symbol(),1440, "TriggerLines",1, i);
  double TriggerBuyD = iCustom(Symbol(),1440, "TriggerLines",2, i);
  double TriggerBuyD2 = iCustom(Symbol(),1440, "TriggerLines",3, i);
  
   if (OrderTyp == OP_BUY)
    {
        if ((TriggerBuyD2 > TriggerBuyD) )
        {retval = false;}
     }
     else if (OrderTyp == OP_SELL) 
     {
        if ((TriggerSellD2 < TriggerSellD) )
        {retval = false;}
     }
  }
  
 
 if ((retval==true) && (UseNewTrend==true)) {
 double NewTrendSilver = iCustom(Symbol(),Period(), "NewTrend",14,9,0, i);
 double NewTrendOrange = iCustom(Symbol(),Period(), "NewTrend",14,9,1, i);
 double Perc = MathAbs(1-(NewTrendSilver/NewTrendOrange))*100;
 
  if (OrderTyp == OP_BUY)
    {
      if ((NewTrendSilver > NewTrendOrange) && (Perc > NTMinGap)   )
      //if ((Juice >= minJuice) && (adx >= MinADX)  )(SolarWind >= minSolarWind) && (Juice >= minJuice) &&&& (greenflattrend>0)
         {
            retval = true;                     
         }
      else
         {
            retval = false;
         }
     }
     else if (OrderTyp == OP_SELL) 
     {
     if ((NewTrendSilver < (NewTrendOrange))  && (Perc > NTMinGap)  )
     //if ((Osma <= -minOsma)  && (SolarWind <= minSolarWind) && (Juice >= minJuice) && (adxvalid == true) && (redflattrend>0)  )
      //   if ((Juice >= minJuice) && (adx >= MinADX)  )
         {
            retval = true;
         }
       else
         {
            retval = false;
         }
     }
    }
    
    if ((retval==true) && (SWConfirm==true)) {
      double SolarWind = iCustom(Symbol(),Period(), "solar winds",0, i); //shift one to get last bar
    if (OrderTyp == OP_BUY)
    {
      if (SolarWind < 0 )
         {
            retval = false;
         }
     }
     else if (OrderTyp == OP_SELL) 
     {
     if (SolarWind > 0 )  
         {
            retval = false;
         }
     }
   }
   
   
    if ((retval==true) && (ema50confirm==true)) {
      double ema50 = iMA(Symbol(),Period(), 50, 0, MODE_EMA,PRICE_CLOSE,i); //shift one to get last bar
      
    if (OrderTyp == OP_BUY) // price should be above ema
    {
      if (ema50 < Low[i] )
         {
            retval = false;
         }
     }
     else if (OrderTyp == OP_SELL)  // price should be below ema
     {
     if  (ema50 > High[i] )
         {
            retval = false;
         }
     }
   }
   
   return(retval);
}


