// 3 bars indicator from "Mastering The Trade"
#property copyright "Copyright  2005 RR"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Yellow

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
    // Reversal bars
    SetIndexStyle(0,DRAW_HISTOGRAM);
    SetIndexBuffer(0,ExtMapBuffer1);
    SetIndexStyle(1,DRAW_HISTOGRAM);
    SetIndexBuffer(1,ExtMapBuffer2);

    // Long signals
    SetIndexStyle(2,DRAW_ARROW,EMPTY,2);
    SetIndexArrow(2,221);
    SetIndexBuffer(2,ExtMapBuffer3);
    SetIndexEmptyValue(2,0.0);
    SetIndexDrawBegin(2,4);
   
    // Short signals
    SetIndexStyle(3,DRAW_ARROW,EMPTY,2);
    SetIndexArrow(3,222);
    SetIndexBuffer(3,ExtMapBuffer4);
    SetIndexEmptyValue(3,0.0);
    SetIndexDrawBegin(3,4);
 
    // Extra buffer to hold last signal value  
    SetIndexBuffer(4,ExtMapBuffer5);
    SetIndexEmptyValue(4,0.0);
    SetIndexStyle(4,DRAW_LINE);
    SetIndexDrawBegin(4,4);

    // 1 if long, -1 if short, 0 if nothing
    SetIndexBuffer(5,ExtMapBuffer6);
    SetIndexStyle(5,DRAW_NONE);
//----
    return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
    double h, l, c, c1, c2, stop1, stop, state1, state;
    int    counted_bars = IndicatorCounted();
//---- 
    //---- last counted bar will be recounted
    if(counted_bars > 0) counted_bars--;
    int limit = Bars-4-counted_bars;
    //---- macd counted in the 1-st additional buffer
    for(int i = limit; i >= 0; i--)
    {    
        c = Close[i];
        c1 = Close[i+1];
        c2 = Close[i+2];
        // First we check if we have lowest/highest bar i+2
        h = High[i+2];
        l = Low[i+2];
        stop1 = ExtMapBuffer5[i+1];
        state1 = ExtMapBuffer6[i+1];
        stop = stop1;
        state = state1;
        // Reset state if stop taken
        if ((state == 1 && l < stop) || (state == -1 && h > stop)) 
        {
            state = 0;
            stop = 0;
        }
        if (state1 <= 0 && l == Low[ArrayMinimum(Low, 5, i)])
            if ((c >= c1 && c1 > c2) ||         // higher closes
                (High[i+1] > h && c >= c1 && c >= c1) ||   // higher high, higher third close
                (High[i] > h && c1 >= c2 && c >= c2))     // higher high, higher third close
            {
                // Previous bar must not be signal
                if (ExtMapBuffer4[i+1] == 0)
                {
                    ExtMapBuffer1[i+2] = High[i+2];
                    ExtMapBuffer2[i+2] = Low[i+2];
                    ExtMapBuffer3[i] = c;
                    ExtMapBuffer5[i+1] = 0;
                    stop = l;
                    state = 1;
                }
                else
                {
                    stop = 0;
                    state = 0;                    
                }
            }
        if (state1 >= 0 && h == High[ArrayMaximum(High, 5, i)])
            if ((c <= c1 && c1 < c2) ||
                (Low[i+1] < l && c <= c1 && c <= c2) ||
                (Low[i] < l && c1 <= c2 && c <= c2))
            {
                if (ExtMapBuffer3[i+1] == 0)
                {
                    ExtMapBuffer1[i+2] = High[i+2];
                    ExtMapBuffer2[i+2] = Low[i+2];
                    ExtMapBuffer4[i] = c;
                    ExtMapBuffer5[i+1] = 0;
                    stop = h;
                    state = -1;
                }
                else
                {
                    stop = 0;
                    state = 0;                    
                }
            }
        ExtMapBuffer5[i] = stop;
        ExtMapBuffer6[i] = state;
    }       
 
//----
   return(0);
  }
//+------------------------------------------------------------------+