#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

#property  indicator_separate_window

#property  indicator_buffers 1
#property  indicator_color1  Red


#property indicator_level1 0
#property indicator_levelcolor DimGray
#property indicator_levelstyle STYLE_SOLID
#property indicator_levelwidth 0


#define  LENGTH		1000

//---- 

extern int periodFast = 5;
extern int periodSlow = 12;
extern int maType     = 1; // 1=EMA
extern int maPrice     = 0; // 0=close

double     ExtBuffer0[];
double     buffer1[1000], buffer2[1000];

//------------------------------------------------------------------+

int init()
{
   switch(maType)
   {
      case 0:
         string type = "SMA"; 
         break;
      case 1:
         type = "EMA";
         break;
      case 2:
         type = "SMMA";
         break;
      case 3:
         type = "LWMA";
         break;
   }

   IndicatorDigits(Digits);
   IndicatorShortName("Zro Retard "+type+" Periodes = "+periodFast+" / "+periodSlow+" ");

   IndicatorBuffers(1);

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtBuffer0);
   
   ArrayInitialize(buffer1,0.0);
   ArrayInitialize(buffer2,0.0);
   
   ArraySetAsSeries(buffer1,True);
   ArraySetAsSeries(buffer2,True);

   return(0);
}

//------------------------------------------------------------------+

int deinit()
{

   return(0);
}

//------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int limit, i;
   
   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   if (limit > LENGTH) limit = LENGTH;
  
   for(i=limit; i>=0; i--)  {
   
      //MM Courte 
      buffer1[i] = iMA(NULL, 0, periodFast, 0, maType, PRICE_CLOSE, i);
      double ma5 = iMAOnArray(buffer1,0, periodFast, 0, maType, i);
      double diff=buffer1[i]-ma5;
      double indic=buffer1[i]+diff;

      //MM longue 
      buffer2[i] = iMA(NULL, 0, periodSlow, 0, maType, PRICE_CLOSE, i);
      double ma5L = iMAOnArray(buffer2, 0, periodSlow, 0, maType, i);
      double diffL=buffer2[i]-ma5L;
      double indicL=buffer2[i]+diffL;

      ExtBuffer0[i]=indic-indicL;
   }


return(0);
}
//------------------------------------------------------------------+

