//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "by Shimodax, 2005"
#property  link      "http://www.strategybuilder.com"


//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color2  HotPink
#property  indicator_color1  White




//---- indicator parameters
extern int Mode= 2;
extern int PFE_Period= 8;
extern int PFE_Smooth= 5;


//---- indicator buffers
double     BufferGreen[];
double     BufferHidden[];

double oldbuffhidden;
double bufhidden1;
string symbolTxt;
int alertTag;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2);
   
   //---- drawing settings
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   // SetIndexDrawBegin(0,PFE_Period+PFE_Smooth);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);


   //---- 3 indicator buffers mapping
   if(!SetIndexBuffer(1,BufferGreen) || 
!SetIndexBuffer(0,BufferHidden))
      Alert("cannot set indicator buffers!");
      
//   ArrayInitialize(BufferGreen, 0);
//   ArrayInitialize(BufferHidden, 0);
      
   //---- name for DataWindow and indicator subwindow label
   IndicatorShortName("PFE("+PFE_Period+", Mode "+Mode+")");
   
   //---- initialization done
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{   
   static double lastsignal= 0.0;   
   double signal;
   int counted_bars= IndicatorCounted(),
         lastbar;

   if (counted_bars>0)
      counted_bars--;
      
   lastbar= Bars- counted_bars;
 
   PFE(0, lastbar, BufferGreen, BufferHidden, PFE_Period, PFE_Smooth);

   return (0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

double ROC(int shift) 
{
      /* TRADESTATION/METASTOCK ROC
      
      * ROC     = ((price/prevPrice)-1)*100   [Rate of change]
      *
      *
      * ROC and ROCP are centered at zero and can have positive and 
negative
      * value. Here are some equivalence:
      *    ROC = ROCP/100 
      *        = ((price-prevPrice)/prevPrice)/100
      *        = ((price/prevPrice)-1)*100
      *
      * ROCR and ROCR100 are ratio respectively centered at 1 and 100 
and are
      * always positive values.
      */
      
   if (Close[shift+1]==0) {
      Print(Bars, ", ", shift);
   }
      
   double rc= (Close[shift]/Close[shift+1] -1 ) * 100;
   return (rc);
}


int PFE(int offset, int lastbar, double &bufgreen[], double &bufhidden[], int period, int smooth)
{
   double sma1, sma2, sma1prev, diff, diff2;
   
  
   lastbar= MathMin(Bars-period-smooth-2, lastbar);

   for(int shift= lastbar; shift>= 0; shift--) {
   
      bufgreen[shift]= 10;
        

      bufhidden[shift]= 0;


      /* PFE TradeStation
         Mov(
           If(C > Ref(C,-9), 

              Sqr( Pwr( ROC(C,9,$),2) + Pwr(10,2) ) / 
                       Sum(Sqr( Pwr( ROC(C,1,$),2) +1), 9),
         
              -Sqr( Pwr( ROC(C,9,$),2) + Pwr( 10,2)) / 
                       Sum(Sqr (Pwr(ROC(C,1,$),2) +1), 9)
            ) 
            * 100,5,E
         )

      PFE Amibroker:
         period=10; 
         x=sqrt((ROC(C,9)*ROC(C,9))+100);
         y=Sum(sqrt((ROC(C,1)* ROC(C,1))+1),period);
         z=(x/y);
         pfe=EMA(IIf(C>Ref(C,-9),z,-z)*100,5);
 
      */
   
      if (Mode==1) {
         double d1, d2, d3, d4;
      
         d1= MathSqrt( MathPow( ROC(shift+period-1), 2) + MathPow(period,2));
      
         d2= 0;
         for (int i= 0; i<=period; i++) {
            d3= MathSqrt( MathPow( ROC(shift+i),2) + 1);
            d2+= d3;
         }

         d4= (d1/d2)*100;
      
         if (Close[shift] < Close[shift+period-1]) {
            d4= -d4;
         }
      
         bufhidden[shift]= d4;
      }

      if (Mode==2) { 
      
        /*
         PFE-Improved:
            Periods := Input("Time Periods",1,1000,10);
            Lookback := Periods - 1;
            Sign := If(CLOSE - Ref(C,-9) >=0 ,1,-1);
            a:=Mov(
                  Sign*(
                     1+(Log(   
Sum(Sqr(Pwr(ROC(C,1,$),2)+1),9{Lookback})
                           )/Log(10) 
                        - 
Log(Sqr(Pwr(ROC(C,9{Lookback},$),2)+Pwr(Periods,2)))/Log(10)) / ( Log(periods)/Log(10)
                   )
               ),5,E);
            Pwr(10,LastValue(Abs(a)+PREV-PREV))*sign
         */
      
         double rocP = Close[shift] / Close[shift+period-1];
         
         double sum = 0.0;
         for(int j=shift+period-1;j>=shift;j--) {
            double roc1 = Close[j] / Close[j+1];
            sum += MathSqrt(roc1 * roc1 + 1);
         }

         double t = (MathLog(sum) / MathLog(10.0) - MathLog(MathSqrt(rocP * rocP + period * period))) / MathLog(10.0) + 1.0;
         
         if (Close[shift] - Close[shift+period-1] < 0.0)
            t = -t;
       
         bufhidden[shift] = (t / (MathLog(period)/MathLog(10.0)) + 0.5) * 100.0;
       //  Comment (bufhidden[shift]," " ,shift,oldbuffhidden);
         
         bufhidden1=bufhidden[shift];
         
         if (oldbuffhidden>50 && bufhidden1<50 && shift==0 && alertTag != Time[0])
         {
         Alert (Symbol()," Possible sling!! DOWN");
          alertTag = Time[0];
         }
         if (oldbuffhidden<50 && bufhidden1>50 && shift==0 &&alertTag != Time[0])
         {
         Alert (Symbol()," Possible sling!! UP");
          alertTag = Time[0];
         }
         
      }
      
      
      if (Mode==3) {  
      
        if (Close[shift] - Close[shift+period-1] < 0.0)
            bufhidden[shift]= -100;
        else 
            bufhidden[shift]= +100;
            
      }
      oldbuffhidden= bufhidden[shift];//Print("exit");  
   }     



   for (shift= lastbar; shift>=0; shift--) {      
      bufgreen[shift]=  iMAOnArray(bufhidden, Bars, smooth, 0, MODE_EMA, shift);
   }
   
     
   
   return(0);
}



